// copyright 2022 zamfofex
// license: AGPLv3 or later

#include <stdlib.h>
#include <string.h>
#include <stddef.h>

#include <mimimi/allocators.h>
#include <mimimi/malloc.h>

static void *mimimi_malloc_allocate(unsigned int size)
{
	void *data = malloc(size);
	if (data == NULL) for (;;) { }
	return data;
}

static void *mimimi_malloc_reallocate(void *data0, unsigned int size)
{
	void *data = malloc(size);
	if (data == NULL) for (;;) { }
	memcpy(data, data0, size);
	free(data0);
	return data;
}

static struct mimimi_allocator mimimi_malloc_value = {&mimimi_malloc_allocate, &mimimi_malloc_reallocate, &free, NULL};

struct mimimi_allocator *mimimi_malloc = &mimimi_malloc_value;
